//this file is part of aMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.amule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//#include "stdafx.h"
#include "wintypes.h"
#include "UploadQueue.h"
#include "ClientList.h"
#include "amule.h"
#include "otherfunctions.h"


CClientList::CClientList(){
}

CClientList::~CClientList(){
}

// xrmb : statsclientstatus
void CClientList::GetStatistics(uint32 &totalclient, int stats[], CMap<uint8, uint8, uint32, uint32> *clientStatus, CMap<uint16, uint16, uint32, uint32> *clientVersionEDonkey, CMap<uint16, uint16, uint32, uint32> *clientVersionEDonkeyHybrid, CMap<uint8, uint8, uint32, uint32> *clientVersionEMule){
	//if(clientStatus)		clientStatus->RemoveAll();
	totalclient = list.GetCount();
	if(clientVersionEDonkey)	clientVersionEDonkey->RemoveAll();
	if(clientVersionEMule)		clientVersionEMule->RemoveAll();
	POSITION pos1, pos2;

	for (int i=0;i<8;i++) stats[i]=0;

	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
		CUpDownClient* cur_client =	list.GetAt(pos2);
		
		switch (cur_client->GetClientSoft()) {
			case SO_UNKNOWN : stats[0]++;break;
			case SO_EDONKEY : 
				stats[1]++;
				if(clientVersionEDonkey)
					(*clientVersionEDonkey)[cur_client->GetVersion()]++;
				break;
			case SO_EDONKEYHYBRID : 
				stats[4]++;
				if(clientVersionEDonkeyHybrid)
					(*clientVersionEDonkeyHybrid)[cur_client->GetVersion()]++;
				break;
			case SO_EMULE   :
			case SO_OLDEMULE:
				stats[2]++;
				if(clientVersionEMule) {
					uint8 version = cur_client->GetMuleVersion();
					(*clientVersionEMule)[version]++;
				}
				break;
			case SO_CDONKEY : //Didn't get much time to test this "aMule Compatable" feature.
				stats[5]++;
				break;
			case SO_LXMULE:
				stats[6]++;
				break;
			case SO_AMULE:
				stats[6]++;
				break;
			case SO_MLDONKEY:
				stats[3]++;
				break;
			case SO_NEW_MLDONKEY:
				stats[7]++;
				break;
		}

		//if(clientStatus) (*clientStatus)[cur_client->GetDownloadState()]++;
	}
}


void CClientList::AddClient(CUpDownClient* toadd,bool bSkipDupTest){
	if ( !bSkipDupTest){
		if(list.Find(toadd))
			return;
	}
	list.AddTail(toadd);
}

void CClientList::RemoveClient(CUpDownClient* toremove){
	POSITION pos = list.Find(toremove);
	if (pos){
		//just to be sure...
		theApp.uploadqueue->RemoveFromUploadQueue(toremove);
		theApp.uploadqueue->RemoveFromWaitingQueue(toremove);
		theApp.downloadqueue->RemoveSource(toremove);
		list.RemoveAt(pos);
	}
}

void CClientList::DeleteAll(){
	theApp.uploadqueue->DeleteAll();
	theApp.downloadqueue->DeleteAll();
	POSITION pos1, pos2;
	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
		CUpDownClient* cur_client =	list.GetAt(pos2);
		list.RemoveAt(pos2);
		delete cur_client; // recursiv: this will call RemoveClient
	}
}

bool CClientList::AttachToAlreadyKnown(CUpDownClient** client, CClientReqSocket* sender){
	POSITION pos1, pos2;
	CUpDownClient* tocheck = (*client);
	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
		CUpDownClient* cur_client =	list.GetAt(pos2);
		if (tocheck == cur_client) {
			return true;
		}
		if (tocheck->Compare(cur_client)){
			if (sender){
				if (cur_client->socket){
					cur_client->socket->client = 0;
					cur_client->socket->Safe_Delete();
				}
				cur_client->socket = sender;
				tocheck->socket = 0;
			}
			*client = 0;
			delete tocheck;
			*client = cur_client;
			return true;
		}
	}
	return false;
}

CUpDownClient* CClientList::FindClientByIP(uint32 clientip,uint16 port){
	POSITION pos1, pos2;
	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
		CUpDownClient* cur_client =	list.GetAt(pos2);
		if (cur_client->GetIP() == clientip && cur_client->GetUserPort() == port)
			return cur_client;
	}
	return 0;
}

CUpDownClient* CClientList::FindClientByUserHash(uchar* clienthash){
	POSITION pos1, pos2;
	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
		CUpDownClient* cur_client =	list.GetAt(pos2);
		if (memcmp(cur_client->GetUserHash() ,clienthash,16)  )
				return cur_client;
	}
	return 0;
}


void CClientList::Debug_SocketDeleted(CClientReqSocket* deleted){
	POSITION pos1, pos2;
	for (pos1 = list.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		list.GetNext(pos1);
	}
}

bool CClientList::Debug_IsValidClient(CUpDownClient* tocheck){
	return list.Find(tocheck);
}

/* Maella -Support for tag ET_MOD_VERSION 0x55 II-
void CClientList::AddClientType(EClientSoftware clientSoft, const CString& description){
	// Update in real time the maps
	switch(clientSoft){
		case SO_EDONKEY:{
				ClientMap::iterator it = m_eDonkeyMap.find(description);
				if(it == m_eDonkeyMap.end())
					m_eDonkeyMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_EDONKEYHYBRID:{
				ClientMap::iterator it = m_eDonkeyHybridMap.find(description);
				if(it == m_eDonkeyHybridMap.end())
					m_eDonkeyHybridMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_EMULE:{
				ClientMap::iterator it = m_eMuleMap.find(description);
				if(it == m_eMuleMap.end())
					m_eMuleMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_CDONKEY:{
				ClientMap::iterator it = m_cDonkeyMap.find(description);
				if(it == m_cDonkeyMap.end())
					m_cDonkeyMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_LXMULE:{
				ClientMap::iterator it = m_lMuleMap.find(description);
				if(it == m_lMuleMap.end())
					m_lMuleMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_AMULE:{
				ClientMap::iterator it = m_lMuleMap.find(description);
				if(it == m_lMuleMap.end())
					m_lMuleMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_SHAREAZA:{
				ClientMap::iterator it = m_shareazaMap.find(description);
				if(it == m_shareazaMap.end())
					m_shareazaMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		case SO_MLDONKEY:{
				ClientMap::iterator it = m_oldMlDonkeyMap.find(description);
				if(it == m_oldMlDonkeyMap.end())
					m_oldMlDonkeyMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break;
		default:{ // Don't forget to add here new type of clients
				ClientMap::iterator it = m_unknownMap.find(description);
				if(it == m_unknownMap.end())
					m_unknownMap[description] = 1; // First inscription
				else
					it->second++;
			}
			break; 
	}
}

void CClientList::RemoveClientType(EClientSoftware clientSoft, const CString& description){
	// Update in real time the maps
	switch(clientSoft){
		case SO_EDONKEY:{
				ClientMap::iterator it = m_eDonkeyMap.find(description);
				if(it != m_eDonkeyMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_eDonkeyMap.erase(it);
			}
			break;
		case SO_EDONKEYHYBRID:{
				ClientMap::iterator it = m_eDonkeyHybridMap.find(description);
				if(it != m_eDonkeyHybridMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_eDonkeyHybridMap.erase(it);
			}
			break;
		case SO_EMULE:{
				ClientMap::iterator it = m_eMuleMap.find(description);
				if(it != m_eMuleMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_eMuleMap.erase(it);
			}
			break;
		case SO_CDONKEY:{
				ClientMap::iterator it = m_cDonkeyMap.find(description);
				if(it != m_cDonkeyMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_cDonkeyMap.erase(it);
			}
			break;
		case SO_LXMULE:{
				ClientMap::iterator it = m_lMuleMap.find(description);
				if(it != m_lMuleMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_lMuleMap.erase(it);
			}
			break;
		case SO_AMULE:{
				ClientMap::iterator it = m_lMuleMap.find(description);
				if(it != m_lMuleMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_lMuleMap.erase(it);
			}
			break;
		case SO_SHAREAZA:{
				ClientMap::iterator it = m_shareazaMap.find(description);
				if(it != m_shareazaMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_shareazaMap.erase(it);
			}
			break;
		case SO_MLDONKEY:{
				ClientMap::iterator it = m_oldMlDonkeyMap.find(description);
				if(it != m_oldMlDonkeyMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_oldMlDonkeyMap.erase(it);
			}
			break;
		default:{  // Don't forget to add here new type of clients
				ClientMap::iterator it = m_unknownMap.find(description);
				if(it != m_unknownMap.end())
					if(it->second > 1)
						it->second--;
					else
						m_unknownMap.erase(it);
			}
			break;
	}
}
// Maella end
*/